open Location
type type_fun = Types.t -> bool -> Types.t

module Unary: sig
  include Custom.T with type t = int

  val register: 
    string -> 
    (Typer.t -> 'a) ->
    ('a -> loc -> type_fun -> type_fun) ->
    ('a -> Value.t -> Value.t) ->
    ('a Serialize.Put.f) ->
    ('a Serialize.Get.f) -> unit
end


module Binary: sig
  include Custom.T with type t = int

  val register: 
    string -> 
    (Typer.t -> 'a) ->
    ('a -> loc -> type_fun -> type_fun -> type_fun) ->
    ('a -> Value.t -> Value.t -> Value.t) ->
    ('a Serialize.Put.f) ->
    ('a Serialize.Get.f) -> unit
end
